if select(2, UnitClass('player')) ~= 'ROGUE' then
	DisableAddOn('Assassin')
	return
end

Assassin = {}

SLASH_Assassin1, SLASH_Assassin2 = '/assassin', '/ass'
BINDING_HEADER_ASSASSIN = 'Assassin'

local function InitializeVariables()
	for k, v in pairs({ -- defaults
		locked = false,
		scale_main = 1,
		scale_previous = 0.7,
		scale_cooldown = 0.7,
		scale_interrupt = 0.4,
		frequency = 0.05,
		previous = true,
		always_on = false,
		cooldown = true,
		aoe = false,
		gcd = true,
		dimmer = true,
		miss_effect = true,
		glow = true,
		boss_only = false,
		hide_spec = 0,
		interrupt = false,
		pot = false,
		front = false,
		stealth = false,
		poison = true,
		tricks = false
	}) do
		if Assassin[k] == nil then
			Assassin[k] = v
		end
	end
end

local events, abilities, glows = {}, {}, {}
local me, abilityTimer, currentTime, currentSpec, targetMode, combatStartTime = 0, 0, 0, 0, 0, 0

local assassinPanel = CreateFrame('Frame', 'assassinPanel', UIParent)
assassinPanel:SetPoint('CENTER', 0, -169)
assassinPanel:SetFrameStrata('BACKGROUND')
assassinPanel:SetSize(64, 64)
assassinPanel:SetMovable(true)
assassinPanel:Hide()
assassinPanel.icon = assassinPanel:CreateTexture(nil, 'BACKGROUND')
assassinPanel.icon:SetAllPoints(assassinPanel)
assassinPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
assassinPanel.border = assassinPanel:CreateTexture(nil, 'BORDER')
assassinPanel.border:SetAllPoints(assassinPanel)
assassinPanel.border:SetTexture('Interface\\AddOns\\Assassin\\border.blp')
assassinPanel.border:Hide()
assassinPanel.gcd = CreateFrame('Cooldown', nil, assassinPanel, 'CooldownFrameTemplate')
assassinPanel.gcd:SetAllPoints(assassinPanel)
assassinPanel.dimmer = assassinPanel:CreateTexture(nil, 'OVERLAY')
assassinPanel.dimmer:SetAllPoints(assassinPanel)
assassinPanel.dimmer:SetTexture(0, 0, 0, 0.6)
assassinPanel.dimmer:Hide()
assassinPanel.targets = assassinPanel:CreateFontString(nil, 'OVERLAY')
assassinPanel.targets:SetFont('Fonts\\FRIZQT__.TTF', 12, 'OUTLINE')
assassinPanel.targets:SetPoint('BOTTOMRIGHT', assassinPanel, 'BOTTOMRIGHT', -1.5, 3)
assassinPanel.button = CreateFrame('Button', 'assassinPanelButton', assassinPanel)
assassinPanel.button:SetAllPoints(assassinPanel)
assassinPanel.button:RegisterForClicks('LeftButtonDown', 'RightButtonDown', 'MiddleButtonDown')
local assassinPreviousPanel = CreateFrame('Frame', 'assassinPreviousPanel', UIParent)
assassinPreviousPanel:SetPoint('BOTTOMRIGHT', assassinPanel, 'BOTTOMLEFT', -10, -5)
assassinPreviousPanel:SetFrameStrata('BACKGROUND')
assassinPreviousPanel:SetSize(64, 64)
assassinPreviousPanel:Hide()
assassinPreviousPanel:RegisterForDrag('LeftButton')
assassinPreviousPanel:SetScript('OnDragStart', assassinPreviousPanel.StartMoving)
assassinPreviousPanel:SetScript('OnDragStop', assassinPreviousPanel.StopMovingOrSizing)
assassinPreviousPanel:SetMovable(true)
assassinPreviousPanel.icon = assassinPreviousPanel:CreateTexture(nil, 'BACKGROUND')
assassinPreviousPanel.icon:SetAllPoints(assassinPreviousPanel)
assassinPreviousPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
assassinPreviousPanel.border = assassinPreviousPanel:CreateTexture(nil, 'BORDER')
assassinPreviousPanel.border:SetAllPoints(assassinPreviousPanel)
assassinPreviousPanel.border:SetTexture('Interface\\AddOns\\Assassin\\border.blp')
local assassinCooldownPanel = CreateFrame('Frame', 'assassinCooldownPanel', UIParent)
assassinCooldownPanel:SetPoint('BOTTOMLEFT', assassinPanel, 'BOTTOMRIGHT', 10, -5)
assassinCooldownPanel:SetSize(64, 64)
assassinCooldownPanel:SetFrameStrata('BACKGROUND')
assassinCooldownPanel:Hide()
assassinCooldownPanel:RegisterForDrag('LeftButton')
assassinCooldownPanel:SetScript('OnDragStart', assassinCooldownPanel.StartMoving)
assassinCooldownPanel:SetScript('OnDragStop', assassinCooldownPanel.StopMovingOrSizing)
assassinCooldownPanel:SetMovable(true)
assassinCooldownPanel.icon = assassinCooldownPanel:CreateTexture(nil, 'BACKGROUND')
assassinCooldownPanel.icon:SetAllPoints(assassinCooldownPanel)
assassinCooldownPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
assassinCooldownPanel.border = assassinCooldownPanel:CreateTexture(nil, 'BORDER')
assassinCooldownPanel.border:SetAllPoints(assassinCooldownPanel)
assassinCooldownPanel.border:SetTexture('Interface\\AddOns\\Assassin\\border.blp')
assassinCooldownPanel.poolText = assassinCooldownPanel:CreateFontString(nil, 'OVERLAY')
assassinCooldownPanel.poolText:SetFont('Fonts\\FRIZQT__.TTF', 12, '')
assassinCooldownPanel.poolText:SetTextColor(1, 0.96, 0.41)
assassinCooldownPanel.poolText:SetShadowOffset(1, -1)
assassinCooldownPanel.poolText:SetShadowColor(0, 0, 0, 0.8)
assassinCooldownPanel.poolText:SetPoint('CENTER', assassinCooldownPanel, 'CENTER', 0, -1)
local assassinInterruptPanel = CreateFrame('Frame', 'assassinInterruptPanel', UIParent)
assassinInterruptPanel:SetPoint('TOPLEFT', assassinPanel, 'TOPRIGHT', 16, 25)
assassinInterruptPanel:SetFrameStrata('BACKGROUND')
assassinInterruptPanel:SetSize(64, 64)
assassinInterruptPanel:Hide()
assassinInterruptPanel:RegisterForDrag('LeftButton')
assassinInterruptPanel:SetScript('OnDragStart', assassinInterruptPanel.StartMoving)
assassinInterruptPanel:SetScript('OnDragStop', assassinInterruptPanel.StopMovingOrSizing)
assassinInterruptPanel:SetMovable(true)
assassinInterruptPanel.icon = assassinInterruptPanel:CreateTexture(nil, 'BACKGROUND')
assassinInterruptPanel.icon:SetAllPoints(assassinInterruptPanel)
assassinInterruptPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
assassinInterruptPanel.border = assassinInterruptPanel:CreateTexture(nil, 'BORDER')
assassinInterruptPanel.border:SetAllPoints(assassinInterruptPanel)
assassinInterruptPanel.border:SetTexture('Interface\\AddOns\\Assassin\\border.blp')
assassinInterruptPanel.cast = CreateFrame('Cooldown', nil, assassinInterruptPanel, 'CooldownFrameTemplate')
assassinInterruptPanel.cast:SetAllPoints(assassinInterruptPanel)

local function GetGCD()
	local startTime, duration = GetSpellCooldown(2098)
	return duration - (currentTime - startTime)
end

local Ability = {}
Ability.__index = Ability

function Ability.add(spellId, buff, playerCast, spellId2)
	local name, _, icon = GetSpellInfo(spellId)
	local ability = {
		spellId = spellId,
		spellId2 = spellId2 or 0,
		name = name,
		icon = icon,
		known = IsPlayerSpell(spellId),
		auraTarget = buff and 'player' or 'target',
		auraFilter = (buff and 'HELPFUL' or 'HARMFUL') .. (playerCast and '|PLAYER' or ''),
	}
	setmetatable(ability, Ability)
	abilities[#abilities + 1] = ability
	return ability
end

function Ability:ready(seconds)
	return self:cooldown() <= max(seconds or 0, GetGCD())
end

function Ability:remains()
	local _, id, expires
	for i = 1, 40 do
		_, _, _, _, _, _, expires, _, _, _, id = UnitAura(self.auraTarget, i, self.auraFilter)
		if id == self.spellId or id == self.spellId2 then
			return expires - currentTime
		end
	end
	return 0
end

function Ability:up()
	local _, id
	for i = 1, 40 do
		_, _, _, _, _, _, _, _, _, _, id = UnitAura(self.auraTarget, i, self.auraFilter)
		if id == self.spellId or id == self.spellId2 then
			return true
		end
	end
end

function Ability:down()
	return not self:up()
end

function Ability:cooldown()
	local startTime, duration = GetSpellCooldown(self.spellId)
	return duration - (currentTime - startTime)
end

function Ability:stack()
	local _, id, count
	for i = 1, 40 do
		_, _, _, count, _, _, _, _, _, _, id = UnitAura(self.auraTarget, i, self.auraFilter)
		if id == self.spellId or id == self.spellId2 then
			return count
		end
	end
	return 0
end

function Ability:charges()
	return (GetSpellCharges(self.spellId))
end

-- Rogue abilities
local AdrenalineRush = Ability.add(13750, true, true)
local Ambush = Ability.add(8676, false, true)
local Anticipation = Ability.add(114015, true, true, 115189)
local Backstab = Ability.add(53, false, true)
local BladeFlurry = Ability.add(13877, true, true)
local Blindside = Ability.add(121153, true, true)
local CrimsonTempest = Ability.add(121411, false, true, 122233)
local DeadlyPoison = Ability.add(2823, true, true)
DeadlyPoison.dot = Ability.add(113780, false, true)
local DeathFromAbove = Ability.add(152150, false, true)
local DeepInsight = Ability.add(84747, true, true)
local Dispatch = Ability.add(111240, false, true)
local Envenom = Ability.add(32645, true, true)
local Eviscerate = Ability.add(2098, false, true)
local FanOfKnives = Ability.add(51723, false, true)
local FindWeakness = Ability.add(91021, false, true)
local Hemorrhage = Ability.add(16511, false, true)
local ImprovedSliceAndDice = Ability.add(157513, true, true)
local InstantPoison = Ability.add(157605, true, true, 157584)
local Kick = Ability.add(1766, false, true)
local KillingSpree = Ability.add(51690, true, true)
local MarkedForDeath = Ability.add(137619, false, true)
local MasterOfSubtlety = Ability.add(31665, true, true)
local Mutilate = Ability.add(1329, false, true)
local Premeditation = Ability.add(14183, true, true)
local Preparation = Ability.add(14185, true, true)
local RevealingStrike = Ability.add(84617, false, true)
local Rupture = Ability.add(1943, false, true)
local ShadowDance = Ability.add(51713, true, true)
local ShadowFocus = Ability.add(108209, true, true)
local ShadowReflection = Ability.add(152151, true, true)
local ShurikenToss = Ability.add(114014, false, true)
local SinisterStrike = Ability.add(1752, false, true)
local SleightOfHand = Ability.add(145211, true, true)
local SliceAndDice = Ability.add(5171, true, true)
local Stealth = Ability.add(1784, true, true)
local Subterfuge = Ability.add(108208, true, true)
local TricksOfTheTrade = Ability.add(57934, true, true)
local Vanish = Ability.add(1856, true, true, 11327)
local Vendetta = Ability.add(79140, false, true)
-- Potions
local DraenicAgility = Ability.add(156423, true, true)
-- Overpowered Racials
local Shadowmeld = Ability.add(58984, true, true)
local ArcaneTorrent = Ability.add(25046, true, true)
-- Energy Pool Spell
local PoolSpell = Ability.add(1)
PoolSpell.icon = 'Interface\\AddOns\\Assassin\\poolspell.blp'
-- Anti Blade Flurry
local AntiBladeFlurry = Ability.add(13877, true, true)
AntiBladeFlurry.icon = 'Interface\\Icons\\Ability_Warrior_Warbringer'

local abilityMain, lastAbilityMain, abilityPrevious, abilityCD

local targetModes = {
	[0] = { {1, ''} },
	[1] = {
		{1, ''},
		{4, '4'},
		{5, '5+'}
	},
	[2] = {
		{1, ''},
		{2, '2'},
		{3, '3+'}
	},
	[3] = {
		{1, ''},
		{2, '2'},
		{3, '3'},
		{4, '4'},
		{5, '5+'}
	}
}

local InCombat = InCombatLockdown

local function ComboPoints()
	return UnitPower('player', 4)
end

local EnergyRegen = GetPowerRegen

local function EnergyMax()
	return UnitPowerMax('player', 3)
end

local function Energy()
	return UnitPower('player', 3)
end

local function EnergyTimeToMax()
	return (EnergyMax() - Energy()) / EnergyRegen()
end

local function HealthPercentage()
	return UnitHealth('player') / UnitHealthMax('player') * 100
end

local function Enemies()
	return targetModes[currentSpec][targetMode][1]
end

local function Stealthed()
	return Stealth:up() or Vanish:up() or ShadowDance:up()
end

local function InGroup()
	return UnitInParty('party1')
end

local function PoolEnergy(amount)
	assassinCooldownPanel.poolText:SetText(max(floor(amount - Energy()), 0))
	return PoolSpell
end

local function TimeInCombat()
    return combatStartTime > 0 and currentTime - combatStartTime or 0
end

local Target = {
	boss = false,
	guid = 0,
	healthArray = {},
	hostile = false
}

Target.healthPercentage = function()
	if Target.guid == 0 then
		return 100
	end
	return UnitHealth('target') / UnitHealthMax('target') * 100
end

Target.timeToDie = function()
	local hp = Target.healthArray[1] - Target.healthArray[#Target.healthArray]
	if hp > 0 then
		return UnitHealth('target') / (hp / 3)
	end
	return 600
end

function DraenicAgility:cooldown()
	local startTime, duration = GetItemCooldown(109217)
	return duration - (currentTime - startTime)
end

local function BloodlustRemains()
	local _, id, expires
	for i = 1, 40 do
		_, _, _, _, _, _, expires, _, _, _, id = UnitAura('player', i, 'HELPFUL')
		if id == 2825 or id == 32182 or id == 80353 or id == 90355 or id == 160452 then
			return expires - currentTime
		end
	end
	return 0
end

local function BloodlustActive()
	return BloodlustRemains() > 0
end

local function DetermineAbilityAssassination()
	if Assassin.cooldown and (not Assassin.boss_only or Target.boss) then
		if MarkedForDeath.known and MarkedForDeath:ready() and not InCombat() then
			abilityCD = MarkedForDeath
		elseif Assassin.pot and Target.boss and DraenicAgility:ready() and (BloodlustActive() or Target.timeToDie() < 40) then
			abilityCD = DraenicAgility
		elseif Preparation:ready() and not (Stealthed() or Vanish:ready(60)) then
			abilityCD = Preparation
		elseif ArcaneTorrent.known and ArcaneTorrent:ready() and Energy() < 60 then
			abilityCD = ArcaneTorrent
		elseif Vanish:ready() and TimeInCombat() > 10 and not Stealthed() then
			abilityCD = Vanish
		end
	end
	if not (InCombat() or Vanish:up()) then
		if Assassin.poison and DeadlyPoison:remains() < 300 then
			return DeadlyPoison
		elseif Assassin.stealth and not Stealthed() then
			return Stealth
		elseif not ImprovedSliceAndDice.known and SliceAndDice:remains() < 6 and ComboPoints() > 0 then
			return SliceAndDice
		end
	end
	if Stealthed() then
		return Mutilate
	elseif ComboPoints() == 5 and Rupture:remains() < 7.2 then
		return Rupture
	elseif ComboPoints() > 0 and SliceAndDice:up() and SliceAndDice:remains() < 5 then
		return Envenom
	elseif not ImprovedSliceAndDice.known and ComboPoints() > 0 and SliceAndDice:down() then
		return SliceAndDice
	end
	if not abilityCD and MarkedForDeath.known and MarkedForDeath:ready() and ComboPoints() == 0 then
		abilityCD = MarkedForDeath
	end
	if Enemies() > 3 and ComboPoints() == 5 and CrimsonTempest:remains() < (Enemies() == 4 and 3.6 or 8) then
		return CrimsonTempest
	elseif Enemies() > 3 and ComboPoints() < 5 then
		return FanOfKnives
	elseif Enemies() == 1 and ComboPoints() > 0 and Rupture:remains() < 2 then
		return Rupture
	end
	if not abilityCD and ShadowReflection.known and ShadowReflection:ready() and Vendetta:ready() then
		abilityCD = ShadowReflection
	elseif not abilityCD and Vendetta:ready() and (not ShadowReflection.known or ShadowReflection:up()) then
		abilityCD = Vendetta
	end
	if ComboPoints() == 5 and DeathFromAbove.known and DeathFromAbove:ready() then
		return DeathFromAbove
	elseif Enemies() < 5 and ComboPoints() == 5 and Envenom:remains() < 2 and (not DeathFromAbove:ready(2) or not DeathFromAbove.known) then
		return Envenom
	elseif Enemies() < 5 and Energy() >= 55 and Target.healthPercentage() >= 35 and ComboPoints() < 5 then
		return Mutilate
	elseif Enemies() < 4 and Target.healthPercentage() < 35 and (ComboPoints() < 5 or (Anticipation.known and Anticipation:stack() < 4)) then
		return Dispatch
	elseif Blindside:up() and (ComboPoints() < 5 or (Anticipation.known and Anticipation:stack() < 4)) then
		return Dispatch
	elseif Enemies() > 3 then
		return FanOfKnives
	else
		return Mutilate
	end
end

local function DetermineAbilityCombat()
	if Assassin.cooldown and (not Assassin.boss_only or Target.boss) then
		if MarkedForDeath.known and MarkedForDeath:ready() and not InCombat() then
			abilityCD = MarkedForDeath
		elseif Assassin.pot and Target.boss and DraenicAgility:ready() and (BloodlustActive() or Target.timeToDie() < 40) then
			abilityCD = DraenicAgility
		elseif Preparation:ready() and not (Stealthed() or Vanish:ready(60)) then
			abilityCD = Preparation
		elseif ArcaneTorrent.known and ArcaneTorrent:ready() and Energy() < 60 then
			abilityCD = ArcaneTorrent
		elseif Enemies() > 1 and BladeFlurry:down() and BladeFlurry:ready() then
			abilityCD = BladeFlurry
		elseif Enemies() == 1 and BladeFlurry:up() then
			abilityCD = AntiBladeFlurry
		elseif ShadowReflection.known and ShadowReflection:ready() and ((KillingSpree:ready(10) and ComboPoints() > 3) or AdrenalineRush:up()) then
			abilityCD = ShadowReflection
		end
	end
	if not (InCombat() or Vanish:up()) then
		if Assassin.poison and InstantPoison.known and InstantPoison:remains() < 300 then
			return InstantPoison
		elseif Assassin.poison and not InstantPoison.known and DeadlyPoison:remains() < 300 then
			return DeadlyPoison
		elseif Assassin.stealth and not Stealthed() then
			return Stealth
		elseif SliceAndDice:remains() < 6 and ComboPoints() > 0 then
			return SliceAndDice
		end
	end
	if Stealthed() then
		return Ambush
	end
	if not abilityCD and Vanish:ready() and TimeInCombat() > 10 and (ComboPoints() < 3 or (Anticipation.known and Anticipation:stack() < 3) or (ComboPoints() < 4 or (Anticipation.known and Anticipation:stack() < 4))) and ((ShadowFocus.known and AdrenalineRush:down() and Energy() < 20) or (Subterfuge.known and Energy() >= 90) or (not ShadowFocus.known and not Subterfuge.known and Energy() >= 60)) then
		abilityCD = Vanish
	end
	if SliceAndDice:remains() < 2 or (Target.timeToDie() > 45 and ComboPoints() == 5 and SliceAndDice:remains() < 10.8) then
		return SliceAndDice
	end
	if not abilityCD then
		if KillingSpree:ready() and AdrenalineRush:down() and (Energy() < 40 or (BloodlustActive() and TimeInCombat() < 10) or BloodlustRemains() > 20) and (not ShadowReflection.known or ShadowReflection:cooldown() > 30 or ShadowReflection:remains() > 3) then
			abilityCD = KillingSpree
		elseif AdrenalineRush:ready() and (Energy() < 40 or BloodlustActive()) and not KillingSpree:ready(10) then
			abilityCD = AdrenalineRush
		elseif MarkedForDeath.known and MarkedForDeath:ready() and ComboPoints() < 2 and RevealingStrike:up() and (not ShadowReflection.known or ShadowReflection:up() or ShadowReflection:cooldown() > 30) then
			abilityCD = MarkedForDeath
		end
	end
	if ComboPoints() < 5 or RevealingStrike:down() or (Anticipation.known and Anticipation:stack() < 5 and DeepInsight:down()) then
		if RevealingStrike:down() or (RevealingStrike:remains() < 7.2 and ComboPoints() == 4 and Target.timeToDie() > RevealingStrike:remains()) then
			return RevealingStrike
		else
			return SinisterStrike
		end
	elseif ComboPoints() == 5 and (DeepInsight:up() or not Anticipation.known or (Anticipation.known and Anticipation:stack() > 3)) then
		if not abilityCD then
			if KillingSpree:ready() and AdrenalineRush:down() then
				abilityCD = KillingSpree
			elseif AdrenalineRush:ready() and not KillingSpree:ready(10) then
				abilityCD = AdrenalineRush
			end
		end
		if DeathFromAbove.known and DeathFromAbove:ready() then
			return DeathFromAbove
		elseif Enemies() > 2 or (Enemies() > 1 and CrimsonTempest:remains() < 3.6) then
			return CrimsonTempest
		else
			return Eviscerate
		end
	end
end

local actionListsSubtlety = {
	generator = function()
		if MasterOfSubtlety:down() and ShadowDance:down() and FindWeakness:down() and (Energy() + ShadowDance:cooldown() * EnergyRegen() < 80 or Energy() + Vanish:cooldown() * EnergyRegen() < 60) then
			if Preparation:ready() and not (Stealthed() or Vanish:ready(60)) then
				return Preparation
			end
		elseif Energy() < 30 and Preparation:ready() and not (Stealthed() or Vanish:ready(60)) then
			return Preparation
		elseif Enemies() > 1 then
			return FanOfKnives
		elseif Hemorrhage:remains() < 7.2 and Target.timeToDie() > 10 then
			return Hemorrhage
		elseif Stealthed() or SleightOfHand:up() then
			return Ambush
		elseif ShurikenToss.known and Energy() < 65 and EnergyRegen() < 16 then
			return ShurikenToss
		else
			return Assassin.front and Hemorrhage or Backstab
		end
	end,
	finisher = function()
		if SliceAndDice:remains() < 4 then
			return SliceAndDice
		elseif DeathFromAbove.known and DeathFromAbove:ready() then
			return DeathFromAbove
		elseif Enemies() < 4 and (Rupture:down() or Rupture:remains() < 7.2) then
			return Rupture
		elseif Enemies() > 4 or (Enemies() > 3 and CrimsonTempest:remains() < 3.6) then
			return CrimsonTempest
		elseif Enemies() < 4 then
			return Eviscerate
		end
	end
}

local function DetermineAbilitySubtlety()
	if Assassin.cooldown and (not Assassin.boss_only or Target.boss) then
		if Assassin.pot and Target.boss and DraenicAgility:ready() and (BloodlustActive() or Target.timeToDie() < 40) then
			abilityCD = DraenicAgility
		elseif ArcaneTorrent.known and ArcaneTorrent:ready() and Energy() < 60 then
			abilityCD = ArcaneTorrent
		elseif Premeditation:ready() and Stealthed() and ComboPoints() < 4 then
			abilityCD = Premeditation
		elseif ShadowDance:ready() and FindWeakness:down() and InCombat() and ComboPoints() + Anticipation:stack() < 9 and SleightOfHand:down() and not Stealthed() then
			abilityCD = Energy() >= 75 and ShadowDance or PoolEnergy(75)
		elseif Vanish:ready() and Energy() <= 75 and ComboPoints() < 4 and ShadowDance:down() and MasterOfSubtlety:down() and FindWeakness:down() and SleightOfHand:down() then
			abilityCD = Energy() >= 45 and Vanish or PoolEnergy(45)
		elseif Shadowmeld.known and Shadowmeld:ready() and Energy() <= 75 and ComboPoints() < 4 and ShadowDance:down() and MasterOfSubtlety:down() and FindWeakness:down() and SleightOfHand:down() then
			abilityCD = Energy() >= 45 and Shadowmeld or PoolEnergy(45)
		elseif MarkedForDeath.known and MarkedForDeath:ready() and ComboPoints == 0 then
			abilityCD = MarkedForDeath
		elseif ShadowReflection.known and ShadowReflection:ready() and ShadowDance:up() then
			abilityCD = ShadowReflection
		elseif Assassin.tricks and TricksOfTheTrade:ready() and InGroup() then
			abilityCD = TricksOfTheTrade
		end
	end
	if not (InCombat() or Vanish:up()) then
		if Assassin.poison and DeadlyPoison:remains() < 300 then
			return DeadlyPoison
		elseif Assassin.stealth and not Stealthed() then
			return Stealth
		elseif SliceAndDice:remains() < 6 and ComboPoints() > 0 then
			return SliceAndDice
		end
	end
	if Assassin.poison and DeadlyPoison:down() then
		return DeadlyPoison
	elseif (Stealthed() or SleightOfHand:up()) and (FindWeakness:down() or ComboPoints() < 5 or (Anticipation.known and Anticipation:stack() < 3) or (SleightOfHand:up() and SleightOfHand:remains() < 1.5)) then
		return Ambush
	elseif Anticipation.known and Anticipation:stack() < 3 and SliceAndDice:up() and Rupture:remains() > 2 and (SliceAndDice:remains() > 6 or Rupture:remains() < 4) and (ComboPoints() < 5 or FindWeakness:down()) then
		return actionListsSubtlety.generator()
	elseif ComboPoints() == 5 then
		return actionListsSubtlety.finisher()
	elseif ComboPoints() < 4 or Energy() > 80 or Anticipation.known then
		return actionListsSubtlety.generator()
	elseif Preparation:ready() and not (Stealthed() or Vanish:ready(60)) then
		return Preparation
	end
end

local function DetermineAbility()
	abilityCD = nil
	currentTime = GetTime()
	if currentSpec == 1 then
		return DetermineAbilityAssassination()
	elseif currentSpec == 2 then
		return DetermineAbilityCombat()
	elseif currentSpec == 3 then
		return DetermineAbilitySubtlety()
	end
	assassinPreviousPanel:Hide()
end

local function DetermineInterrupt()
	if Kick:ready() then
		return Kick
	end
end

local function UpdateInterrupt()
	local _, _, _, _, startTime, endTime, _, _, notInterruptible = UnitCastingInfo('target')
	if not startTime or notInterruptible then
		assassinInterruptPanel:Hide()
	else
		assassinInterruptPanel:Show()
		assassinInterruptPanel.cast:SetCooldown(startTime / 1000, (endTime - startTime) / 1000)
		local interrupt = DetermineInterrupt()
		if interrupt then
			assassinInterruptPanel.icon:SetTexture(interrupt.icon)
			assassinInterruptPanel.icon:Show()
			assassinInterruptPanel.border:Show()
		else
			assassinInterruptPanel.icon:Hide()
			assassinInterruptPanel.border:Hide()
		end
	end
end

local function DenyOverlayGlow(actionButton)
	if Assassin.glow then
		actionButton.overlay:Hide()
	end
end

hooksecurefunc('ActionButton_ShowOverlayGlow', DenyOverlayGlow) -- Disable Blizzard's built-in action button glowing

local function CreateOverlayGlows()
	local GenerateGlow = function(button)
		if button then
			local w, h, glow
			w, h = button:GetSize()
			glow = CreateFrame('Frame', nil, button, 'ActionBarButtonSpellActivationAlert')
			glow:Hide()
			glow:SetSize(w * 1.4, h * 1.4)
			glow:SetPoint('TOPLEFT', button, 'TOPLEFT', -w * 0.2, h * 0.2)
			glow:SetPoint('BOTTOMRIGHT', button, 'BOTTOMRIGHT', w * 0.2, -h * 0.2)
			glow.button = button
			glows[#glows + 1] = glow
		end
	end
	if Bartender4 then
		for i = 1, 120 do
			GenerateGlow(_G['BT4Button' .. i])
		end
	elseif ElvUI then
		for b = 1, 6 do
			for i = 1, 12 do
				GenerateGlow(_G['ElvUI_Bar' .. b .. 'Button' .. i])
			end
		end
	else
		for i = 1, 12 do
			GenerateGlow(_G['ActionButton' .. i])
			GenerateGlow(_G['MultiBarLeftButton' .. i])
			GenerateGlow(_G['MultiBarRightButton' .. i])
			GenerateGlow(_G['MultiBarBottomLeftButton' .. i])
			GenerateGlow(_G['MultiBarBottomRightButton' .. i])
		end
		if Dominos then
			for i = 1, 60 do
				GenerateGlow(_G['DominosActionButton' .. i])
			end
		end
	end
end

local function UpdateGlows()
	if Assassin.glow then
		local glow, icon
		for i = 1, #glows do
			glow = glows[i]
			icon = glow.button.icon:GetTexture()
			if icon and ((abilityMain and icon == abilityMain.icon) or (abilityCD and icon == abilityCD.icon)) and glow.button.icon:IsVisible() then
				if not glow:IsVisible() then
					glow.animIn:Play()
				end
			elseif glow:IsVisible() then
				glow.animIn:Stop()
				glow:Hide()
			end
		end
	end
end

local function DisableGlows()
	for i = 1, #glows do
		glows[i].animIn:Stop()
		glows[i]:Hide()
	end
end

function events:ACTIONBAR_SLOT_CHANGED()
	if Assassin.glow then
		UpdateGlows()
	end
end

function events:PLAYER_LOGIN()
	me = UnitGUID('player')
	CreateOverlayGlows()
end

local function Disappear()
	abilityMain = nil
	abilityCD = nil
	DisableGlows()
	assassinPanel:Hide()
	assassinPanel.border:Hide()
	assassinPreviousPanel:Hide()
	assassinCooldownPanel:Hide()
	assassinInterruptPanel:Hide()
end

function Assassin_ToggleTargetMode()
	local mode = targetMode + 1
	Assassin_SetTargetMode(mode > #targetModes[currentSpec] and 1 or mode)
end

function Assassin_ToggleTargetModeReverse()
	local mode = targetMode - 1
	Assassin_SetTargetMode(mode < 1 and #targetModes[currentSpec] or mode)
end

function Assassin_SetTargetMode(mode)
	targetMode = min(mode, #targetModes[currentSpec])
	assassinPanel.targets:SetText(targetModes[currentSpec][targetMode][2])
end

function events:PLAYER_TARGET_CHANGED()
	if Assassin.hide_spec ~= GetActiveSpecGroup() then
		local previouslyHostile = Target.hostile
		Target.hostile = UnitCanAttack('player', 'target') and not UnitInVehicle('player')
		if Target.hostile then
			Target.guid = UnitGUID('target')
			Target.level = UnitLevel('target')
			Target.boss = Target.level == -1 or (Target.level >= UnitLevel('player') + 2 and not UnitInRaid('player'))
			for i = 1, #Target.healthArray do
				Target.healthArray[i] = UnitHealth('target')
			end
			abilityTimer = Assassin.frequency
			assassinPanel:Show()
		elseif Assassin.always_on then
			Target.guid = 0
			Target.boss = false
			Target.hostile = true
			for i = 1, #Target.healthArray do
				Target.healthArray[i] = 0
			end
			abilityTimer = Assassin.frequency
			assassinPanel:Show()
		elseif previouslyHostile then
			Disappear()
		end
	end
end

function events:PLAYER_REGEN_DISABLED()
    combatStartTime = GetTime()
end

function events:PLAYER_REGEN_ENABLED()
    combatStartTime = 0
end

function events:UNIT_FACTION(unitID)
	if unitID == 'target' then
		events:PLAYER_TARGET_CHANGED()
	end
end

--[=[
local function Equipped(slot, item)
	return (GetInventoryItemLink('player', slot) or ''):match('%[([^%]]*)%]') == item and 1 or 0
end

function events:PLAYER_EQUIPMENT_CHANGED()
	-- use for tier bonus checking
end
]=]

function events:PLAYER_SPECIALIZATION_CHANGED(unitName)
	if unitName == 'player' then
		for i = 1, #abilities do
			if abilities[i].spellId ~= 1 then
				abilities[i].name, _, abilities[i].icon = GetSpellInfo(abilities[i].spellId)
				abilities[i].known = IsPlayerSpell(abilities[i].spellId)
			end
		end
		currentSpec = GetSpecialization() or 0
		if Assassin.hide_spec == GetActiveSpecGroup() then
			Disappear()
		end
		Assassin_SetTargetMode(1)
		events:PLAYER_TARGET_CHANGED()
	end
end

function events:PLAYER_ENTERING_WORLD()
	--events:PLAYER_EQUIPMENT_CHANGED()
	events:PLAYER_SPECIALIZATION_CHANGED('player')
end

local function UpdateDraggable()
	assassinPanel:EnableMouse(Assassin.aoe or not Assassin.locked)
	if Assassin.aoe then
		assassinPanel.button:Show()
	else
		assassinPanel.button:Hide()
	end
	if Assassin.locked then
		assassinPanel:SetScript('OnDragStart', nil)
		assassinPanel:SetScript('OnDragStop', nil)
		assassinPanel:RegisterForDrag(nil)
		assassinPreviousPanel:EnableMouse(false)
		assassinCooldownPanel:EnableMouse(false)
		assassinInterruptPanel:EnableMouse(false)
	else
		if not Assassin.aoe then
			assassinPanel:SetScript('OnDragStart', assassinPanel.StartMoving)
			assassinPanel:SetScript('OnDragStop', assassinPanel.StopMovingOrSizing)
			assassinPanel:RegisterForDrag('LeftButton')
		end
		assassinPreviousPanel:EnableMouse(true)
		assassinCooldownPanel:EnableMouse(true)
		assassinInterruptPanel:EnableMouse(true)
	end
end

function events:ADDON_LOADED(name)
	if name == 'Assassin' then
		if not Assassin.frequency then
			print('It looks like this is your first time running Assassin, why don\'t you take some time to familiarize yourself with the commands?')
			print('Type |cFFFFD000/assassin|r for a list of commands.')
		end
		if UnitLevel('player') < 90 then
			print('[|cFFFFD000Warning|r] Assassin is not designed for players under level 90, and almost certainly will not operate properly!')
		end
		InitializeVariables()
		UpdateDraggable()
		assassinPanel:SetScale(Assassin.scale_main)
		assassinPreviousPanel:SetScale(Assassin.scale_previous)
		assassinCooldownPanel:SetScale(Assassin.scale_cooldown)
		assassinInterruptPanel:SetScale(Assassin.scale_interrupt)
		for i = 1, floor(3 / Assassin.frequency) do
			Target.healthArray[i] = 0
		end
	end
end

function events:COMBAT_LOG_EVENT_UNFILTERED(self, eventType, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, spellId)
	if srcGUID == me and Assassin.previous and assassinPanel:IsVisible() then
		if eventType == 'SPELL_MISSED' and Assassin.miss_effect and abilityPrevious and spellId == abilityPrevious.spellId then
			assassinPreviousPanel.border:SetTexture('Interface\\AddOns\\Assassin\\misseffect.blp')
		elseif eventType == 'SPELL_CAST_SUCCESS' and abilityMain and spellId == abilityMain.spellId then
			abilityPrevious = abilityMain
			assassinPreviousPanel.border:SetTexture('Interface\\AddOns\\Assassin\\border.blp')
			assassinPreviousPanel.icon:SetTexture(abilityPrevious.icon)
			assassinPreviousPanel:Show()
		end
	end
end

assassinPanel.button:SetScript('OnClick', function(self, button, down)
	if down then
		if button == 'LeftButton' then
			Assassin_ToggleTargetMode()
		elseif button == 'RightButton' then
			Assassin_ToggleTargetModeReverse()
		elseif button == 'MiddleButton' then
			Assassin_SetTargetMode(1)
		end
	end
end)

assassinPanel:SetScript('OnUpdate', function(self, elapsed)
	abilityTimer = abilityTimer + elapsed
	if abilityTimer >= Assassin.frequency then
		Target.healthArray[#Target.healthArray + 1] = UnitHealth('target')
		table.remove(Target.healthArray, 1)
		lastAbilityMain = abilityMain
		lastAbilityCD = abilityCD
		abilityMain = DetermineAbility()
		if abilityMain ~= lastAbilityMain then
			if abilityMain then
				assassinPanel.icon:SetTexture(abilityMain.icon)
				assassinPanel.icon:Show()
				assassinPanel.border:Show()
			else
				assassinPanel.icon:Hide()
				assassinPanel.border:Hide()
			end
		end
		if abilityCD ~= lastAbilityCD then
			if abilityCD then
				assassinCooldownPanel.icon:SetTexture(abilityCD.icon)
				assassinCooldownPanel:Show()
				if abilityCD ~= PoolSpell then
					assassinCooldownPanel.poolText:SetText('')
				end
			else
				assassinCooldownPanel:Hide()
			end
		end
		if Assassin.glow and (abilityMain ~= lastAbilityMain or abilityCD ~= lastAbilityCD) then
			UpdateGlows()
		end
		if Assassin.gcd then
			local gcdStart, gcdDuration = GetSpellCooldown(2098)
			if gcdStart == 0 then
				assassinPanel.gcd:Hide()
			else
				assassinPanel.gcd:SetCooldown(gcdStart, gcdDuration)
				assassinPanel.gcd:Show()
			end
		end
		if Assassin.dimmer then
			if not abilityMain or IsUsableSpell(abilityMain.spellId) then
				assassinPanel.dimmer:Hide()
			else
				assassinPanel.dimmer:Show()
			end
		end
		if Assassin.interrupt then
			UpdateInterrupt()
		end
		abilityTimer = 0
	end
end)

assassinPanel:SetScript('OnEvent', function(self, event, ...) events[event](self, ...) end)
for event in pairs(events) do
	assassinPanel:RegisterEvent(event)
end

function SlashCmdList.Assassin(msg, editbox)
	msg = { strsplit(' ', strlower(msg)) }
	if msg[1] == 'locked' then
		if msg[2] then
			Assassin.locked = msg[2] == 'on'
			UpdateDraggable()
		end
		print('Assassin - Locked: ' .. (Assassin.locked and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'scale' then
		if msg[2] == 'prev' then
			if msg[3] then
				Assassin.scale_previous = tonumber(msg[3]) or 0.7
				assassinPreviousPanel:SetScale(Assassin.scale_previous)
			end
			print('Assassin - Previous ability icon scale set to: |cFFFFD000' .. Assassin.scale_previous .. '|r times')
		elseif msg[2] == 'main' then
			if msg[3] then
				Assassin.scale_main = tonumber(msg[3]) or 1
				assassinPanel:SetScale(Assassin.scale_main)
			end
			print('Assassin - Main ability icon scale set to: |cFFFFD000' .. Assassin.scale_main .. '|r times')
		elseif msg[2] == 'cd' then
			if msg[3] then
				Assassin.scale_cooldown = tonumber(msg[3]) or 0.7
				assassinCooldownPanel:SetScale(Assassin.scale_cooldown)
			end
			print('Assassin - Cooldown ability icon scale set to: |cFFFFD000' .. Assassin.scale_cooldown .. '|r times')
		elseif msg[2] == 'interrupt' then
			if msg[3] then
				Assassin.scale_interrupt = tonumber(msg[3]) or 0.4
				assassinInterruptPanel:SetScale(Assassin.scale_interrupt)
			end
			print('Assassin - Interrupt ability icon scale set to: |cFFFFD000' .. Assassin.scale_interrupt .. '|r times')
		else
			print('Assassin - Default icon scale options are |cFFFFD000prev 0.7|r, |cFFFFD000main 1|r, |cFFFFD000cd 0.7|r, and |cFFFFD000interrupt 0.4')
		end
	elseif msg[1] == 'frequency' then
		if msg[2] then Assassin.frequency = tonumber(msg[2]) or 0.05 end
		print('Assassin - Calculation frequency: Every |cFFFFD000' .. Assassin.frequency .. '|r seconds')
	elseif msg[1] == 'glow' then
		if msg[2] then
			Assassin.glow = msg[2] == 'on'
			events:PLAYER_TARGET_CHANGED()
		end
		print('Assassin - Glowing ability buttons: ' .. (Assassin.glow and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'previous' then
		if msg[2] then
			Assassin.previous = msg[2] == 'on'
			events:PLAYER_TARGET_CHANGED()
		end
		print('Assassin - Previous ability icon: ' .. (Assassin.previous and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'always' then
		if msg[2] then
			Assassin.always_on = msg[2] == 'on'
			events:PLAYER_TARGET_CHANGED()
		end
		print('Assassin - Show the Assassin UI without a target: ' .. (Assassin.always_on and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'cd' then
		if msg[2] then
			Assassin.cooldown = msg[2] == 'on'
			events:PLAYER_TARGET_CHANGED()
		end
		print('Assassin - Cooldown ability icon: ' .. (Assassin.cooldown and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'gcd' then
		if msg[2] then
			Assassin.gcd = msg[2] == 'on'
			if not Assassin.gcd then
				assassinPanel.gcd:Hide()
			end
		end
		print('Assassin - Global cooldown swipe: ' .. (Assassin.gcd and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'dim' then
		if msg[2] then
			Assassin.dimmer = msg[2] == 'on'
			if not Assassin.dimmer then
				assassinPanel.dimmer:Hide()
			end
		end
		print('Assassin - Dim main ability icon when you don\'t have enough energy to use it: ' .. (Assassin.dimmer and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'miss' then
		if msg[2] then Assassin.miss_effect = msg[2] == 'on' end
		print('Assassin - Red border around previous ability when it fails to hit: ' .. (Assassin.miss_effect and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'aoe' then
		if msg[2] then
			Assassin.aoe = msg[2] == 'on'
			Assassin_SetTargetMode(1)
			UpdateDraggable()
		end
		print('Assassin - Allow clicking main ability icon to toggle amount of targets (disables moving): ' .. (Assassin.aoe and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'bossonly' then
		if msg[2] then Assassin.boss_only = msg[2] == 'on' end
		print('Assassin - Only use cooldowns on bosses: ' .. (Assassin.boss_only and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'hidespec' then
        if msg[2] then
			local spec = tonumber(msg[2]) or 0
			if spec >= 0 and spec <= 2 then
				Assassin.hide_spec = spec
				events:PLAYER_SPECIALIZATION_CHANGED('player')
			end
		end
        print('Assassin - Hide in specialization: |cFFFFD000' .. (Assassin.hide_spec == 0 and 'None' or Assassin.hide_spec))
	elseif msg[1] == 'interrupt' then
		if msg[2] then Assassin.interrupt = msg[2] == 'on' end
		print('Assassin - Show an icon for interruptable spells: ' .. (Assassin.interrupt and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'pot' then
		if msg[2] then Assassin.pot = msg[2] == 'on' end
		print('Assassin - Show Draenic Agility potions in cooldown UI: ' .. (Assassin.pot and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'front' then
		if msg[2] then Assassin.front = msg[2] == 'on' end
		print('Assassin - In front of enemy (can\'t Backstab): ' .. (Assassin.front and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'stealth' then
		if msg[2] then Assassin.stealth = msg[2] == 'on' end
		print('Assassin - Show reminder to Stealth pre-combat: ' .. (Assassin.stealth and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'poison' then
		if msg[2] then Assassin.poison = msg[2] == 'on' end
		print('Assassin - Show 5 minute reminder for poisons: ' .. (Assassin.poison and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'tricks' then
		if msg[2] then Assassin.tricks = msg[2] == 'on' end
		print('Assassin - Show Tricks of the Trade in cooldown UI: ' .. (Assassin.tricks and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'reset' then
		assassinPanel:ClearAllPoints()
		assassinPanel:SetPoint('CENTER', 0, -169)
		assassinPreviousPanel:ClearAllPoints()
		assassinPreviousPanel:SetPoint('BOTTOMRIGHT', assassinPanel, 'BOTTOMLEFT', -10, -5)
		assassinCooldownPanel:ClearAllPoints()
		assassinCooldownPanel:SetPoint('BOTTOMLEFT', assassinPanel, 'BOTTOMRIGHT', 10, -5)
		assassinInterruptPanel:ClearAllPoints()
		assassinInterruptPanel:SetPoint('TOPLEFT', assassinPanel, 'TOPRIGHT', 16, 25)
		print('Assassin - Position has been reset to default')
	else
		print('Assassin (version: |cFFFFD000' .. GetAddOnMetadata('Assassin', 'Version') .. '|r) - Commands:')
		print('  /assassin locked |cFF00C000on|r/|cFFC00000off|r - lock the Assassin UI so that it can\'t be moved')
		print('  /assassin scale |cFFFFD000prev|r/|cFFFFD000main|r/|cFFFFD000cd|r/|cFFFFD000interrupt|r |cFFFFD000[number]|r - adjust the scale of the Assassin UI icons')
		print('  /assassin frequency |cFFFFD000[number]|r - set the calculation frequency (default is every 0.05 seconds)')
		print('  /assassin glow |cFF00C000on|r/|cFFC00000off|r - glowing ability buttons on action bars')
		print('  /assassin previous |cFF00C000on|r/|cFFC00000off|r - previous ability icon')
		print('  /assassin always |cFF00C000on|r/|cFFC00000off|r - show the Assassin UI without a target')
		print('  /assassin cd |cFF00C000on|r/|cFFC00000off|r - cooldown ability icon (turn off for manual cooldown management)')
		print('  /assassin gcd |cFF00C000on|r/|cFFC00000off|r - show global cooldown swipe on main ability icon')
		print('  /assassin dim |cFF00C000on|r/|cFFC00000off|r - dim main ability icon when you don\'t have enough energy to use it')
		print('  /assassin miss |cFF00C000on|r/|cFFC00000off|r - red border around previous ability when it fails to hit')
		print('  /assassin aoe |cFF00C000on|r/|cFFC00000off|r - allow clicking main ability icon to toggle amount of targets (disables moving)')
		print('  /assassin bossonly |cFF00C000on|r/|cFFC00000off|r - only use cooldowns on bosses')
		print('  /assassin hidespec |cFFFFD0000|r/|cFFFFD0001|r/|cFFFFD0002|r - hide Assassin in specialization 1 or 2 (0 is neither)')
		print('  /assassin interrupt |cFF00C000on|r/|cFFC00000off|r - show an icon for interruptable spells')
		print('  /assassin pot |cFF00C000on|r/|cFFC00000off|r - show Draenic Agility potions in cooldown UI')
		print('  /assassin front |cFF00C000on|r/|cFFC00000off|r - in front of enemy (can\'t Backstab)')
		print('  /assassin stealth |cFF00C000on|r/|cFFC00000off|r - show reminder to Stealth pre-combat')
		print('  /assassin poison |cFF00C000on|r/|cFFC00000off|r - show 5 minute reminder for poisons')
		print('  /assassin tricks |cFF00C000on|r/|cFFC00000off|r - show Tricks of the Trade in cooldown UI')
		print('  /assassin |cFFFFD000reset|r - reset the location of the Assassin UI to default')
		if Basic_Resources then
			print('For Basic Resources commands, please type |cFFFFD000/bres')
		end
	end
end